Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateLoadsPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateLoadsPrognostic.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateLoadsPrognostic.cpp	(revision 9405)
@@ -27,7 +27,7 @@
 	
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&prognostic_DG,PrognosticDGEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
-	iomodel->constants->FindParam(&numberofedges,NumberOfEdgesEnum);
+	iomodel->Constant(&prognostic_DG,PrognosticDGEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&numberofedges,NumberOfEdgesEnum);
 
 	/*Recover pointer: */
@@ -47,5 +47,5 @@
 
 			/*Get left and right elements*/
-			element=(int)(iomodel->f(EdgesEnum)[4*i+2])-1; //edges are [node1 node2 elem1 elem2]
+			element=(int)(iomodel->Data(EdgesEnum)[4*i+2])-1; //edges are [node1 node2 elem1 elem2]
 
 			/*Now, if this element is not in the partition, pass: */
Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp	(revision 9405)
@@ -30,8 +30,8 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
-	iomodel->constants->FindParam(&numberofvertices,NumberOfVerticesEnum);
-	iomodel->constants->FindParam(&prognostic_DG,PrognosticDGEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&numberofvertices,NumberOfVerticesEnum);
+	iomodel->Constant(&prognostic_DG,PrognosticDGEnum);
 
 	/*Recover pointer: */
@@ -72,5 +72,5 @@
 
 					//Get index of the vertex on which the current node is located
-					vertex_id=(int)*(iomodel->f(ElementsEnum)+3*i+j); //(Matlab indexing)
+					vertex_id=(int)*(iomodel->Data(ElementsEnum)+3*i+j); //(Matlab indexing)
 					io_index=vertex_id-1;                      //(C indexing)
 					_assert_(vertex_id>0 && vertex_id<=numberofvertices);
Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp	(revision 9405)
@@ -21,7 +21,7 @@
 
 	/*Fetch data needed: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
-	iomodel->constants->FindParam(&prognostic_DG,PrognosticDGEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&prognostic_DG,PrognosticDGEnum);
 	iomodel->FetchData(1,ElementsEnum);
 
Index: issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateNodesSurfaceSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateNodesSurfaceSlope.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateNodesSurfaceSlope.cpp	(revision 9405)
@@ -24,5 +24,5 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&numberofvertices,NumberOfVerticesEnum);
+	iomodel->Constant(&numberofvertices,NumberOfVerticesEnum);
 
 	/*Recover pointer: */
Index: issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/UpdateElementsSurfaceSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/UpdateElementsSurfaceSlope.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/UpdateElementsSurfaceSlope.cpp	(revision 9405)
@@ -20,6 +20,6 @@
 
 	/*Fetch data needed: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
 	iomodel->FetchData(1,ElementsEnum);
 
Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateConstraintsThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateConstraintsThermal.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateConstraintsThermal.cpp	(revision 9405)
@@ -23,5 +23,5 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
+	iomodel->Constant(&dim,DimEnum);
 
 	/*Recover pointer: */
Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateLoadsThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateLoadsThermal.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateLoadsThermal.cpp	(revision 9405)
@@ -26,6 +26,6 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&numberofvertices,NumberOfVerticesEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&numberofvertices,NumberOfVerticesEnum);
 
 	/*Create loads if they do not exist yet*/
@@ -43,5 +43,5 @@
 		/*keep only this partition's nodes:*/
 		if((iomodel->my_vertices[i]==1)){
-			if (isnan(iomodel->f(SpctemperatureEnum)[i])){ //No penalty applied on spc nodes!
+			if (isnan(iomodel->Data(SpctemperatureEnum)[i])){ //No penalty applied on spc nodes!
 				loads->AddObject(new Pengrid(iomodel->loadcounter+i+1,i,iomodel,ThermalAnalysisEnum));
 			}
Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp	(revision 9405)
@@ -24,5 +24,5 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&numberofvertices,NumberOfVerticesEnum);
+	iomodel->Constant(&numberofvertices,NumberOfVerticesEnum);
 
 	/*Recover pointer: */
Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/UpdateElementsThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/UpdateElementsThermal.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/UpdateElementsThermal.cpp	(revision 9405)
@@ -21,7 +21,7 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
-	iomodel->constants->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&qmu_analysis,QmuAnalysisEnum);
 
 	/*Now, is the model 3d? otherwise, do nothing: */
Index: issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp
===================================================================
--- issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 9405)
@@ -26,5 +26,5 @@
 	char       *outputfilename          = NULL;
 	char        cpu_outputfilename[100];        //easier to convert an integer with sprintf
-	bool        io_gather;
+	bool        io_gather,results_on_vertices;
 	int         solutiontype;
 	Results    *results                 = NULL;
Index: issm/trunk/src/c/modules/StringToEnumx/StringToEnumx.cpp
===================================================================
--- issm/trunk/src/c/modules/StringToEnumx/StringToEnumx.cpp	(revision 9403)
+++ issm/trunk/src/c/modules/StringToEnumx/StringToEnumx.cpp	(revision 9405)
@@ -493,4 +493,5 @@
 	else if (strcmp(name,"SpcDynamic")==0) return SpcDynamicEnum;
 	else if (strcmp(name,"NumberOfEdges")==0) return NumberOfEdgesEnum;
+	else if (strcmp(name,"ResultsOnVertices")==0) return ResultsOnVerticesEnum;
 	else _error_("Enum %s not found",name);
 
Index: issm/trunk/src/c/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 9405)
@@ -57,6 +57,6 @@
 	/*Checks in debugging mode*/
 	/*{{{2*/
-	_assert_(iomodel->f(UpperelementsEnum));
-	_assert_(iomodel->f(LowerelementsEnum));
+	_assert_(iomodel->Data(UpperelementsEnum));
+	_assert_(iomodel->Data(LowerelementsEnum));
 	/*}}}*/
 
@@ -66,13 +66,13 @@
 
 	/*Build neighbors list*/
-	if (isnan(iomodel->f(UpperelementsEnum)[index])) penta_elements_ids[1]=this->id; //upper penta is the same penta
-	else                                    penta_elements_ids[1]=(int)(iomodel->f(UpperelementsEnum)[index]);
-	if (isnan(iomodel->f(LowerelementsEnum)[index])) penta_elements_ids[0]=this->id; //lower penta is the same penta
-	else                                    penta_elements_ids[0]=(int)(iomodel->f(LowerelementsEnum)[index]);
+	if (isnan(iomodel->Data(UpperelementsEnum)[index])) penta_elements_ids[1]=this->id; //upper penta is the same penta
+	else                                    penta_elements_ids[1]=(int)(iomodel->Data(UpperelementsEnum)[index]);
+	if (isnan(iomodel->Data(LowerelementsEnum)[index])) penta_elements_ids[0]=this->id; //lower penta is the same penta
+	else                                    penta_elements_ids[0]=(int)(iomodel->Data(LowerelementsEnum)[index]);
 	this->InitHookNeighbors(penta_elements_ids);
 
 	/*Build horizontalneighborsids list: */
-	_assert_(iomodel->f(ElementconnectivityEnum));
-	for(i=0;i<3;i++) this->horizontalneighborsids[i]=(int)iomodel->f(ElementconnectivityEnum)[3*index+i]-1;
+	_assert_(iomodel->Data(ElementconnectivityEnum));
+	for(i=0;i<3;i++) this->horizontalneighborsids[i]=(int)iomodel->Data(ElementconnectivityEnum)[3*index+i]-1;
 
 	//this->parameters: we still can't point to it, it may not even exist. Configure will handle this.
@@ -4860,7 +4860,7 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&numberofvertices,NumberOfVerticesEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
-	iomodel->constants->FindParam(&yts,YtsEnum);
+	iomodel->Constant(&numberofvertices,NumberOfVerticesEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&yts,YtsEnum);
 
 	/*Branch on type of vector: nodal or elementary: */
@@ -4869,5 +4869,5 @@
 		/*Recover vertices ids needed to initialize inputs*/
 		for(i=0;i<6;i++){ 
-			penta_vertex_ids[i]=(int)iomodel->f(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
+			penta_vertex_ids[i]=(int)iomodel->Data(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
 		}
 
@@ -5169,52 +5169,52 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&yts,YtsEnum);
-	iomodel->constants->FindParam(&control_analysis,ControlAnalysisEnum);
-	iomodel->constants->FindParam(&num_control_type,NumControlTypeEnum);
-	iomodel->constants->FindParam(&num_cm_responses,NumCmResponsesEnum);
+	iomodel->Constant(&yts,YtsEnum);
+	iomodel->Constant(&control_analysis,ControlAnalysisEnum);
+	iomodel->Constant(&num_control_type,NumControlTypeEnum);
+	iomodel->Constant(&num_cm_responses,NumCmResponsesEnum);
 
 	/*Checks if debuging*/
 	/*{{{2*/
-	_assert_(iomodel->f(ElementsEnum));
+	_assert_(iomodel->Data(ElementsEnum));
 	/*}}}*/
 
 	/*Recover vertices ids needed to initialize inputs*/
 	for(i=0;i<6;i++){ 
-		penta_vertex_ids[i]=(int)iomodel->f(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
+		penta_vertex_ids[i]=(int)iomodel->Data(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
 	}
 
 	/*Control Inputs*/
-	if (control_analysis && iomodel->f(ControlTypeEnum)){
+	if (control_analysis && iomodel->Data(ControlTypeEnum)){
 		for(i=0;i<num_control_type;i++){
-			switch((int)iomodel->f(ControlTypeEnum)[i]){
+			switch((int)iomodel->Data(ControlTypeEnum)[i]){
 				case DhdtEnum:
-					if (iomodel->f(DhdtEnum)){
-						for(j=0;j<6;j++)nodeinputs[j]=iomodel->f(DhdtEnum)[penta_vertex_ids[j]-1]/yts;
-						for(j=0;j<6;j++)cmmininputs[j]=iomodel->f(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
-						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->f(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
+					if (iomodel->Data(DhdtEnum)){
+						for(j=0;j<6;j++)nodeinputs[j]=iomodel->Data(DhdtEnum)[penta_vertex_ids[j]-1]/yts;
+						for(j=0;j<6;j++)cmmininputs[j]=iomodel->Data(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
+						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->Data(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
 						this->inputs->AddInput(new ControlInput(DhdtEnum,PentaVertexInputEnum,nodeinputs,cmmininputs,cmmaxinputs,i+1));
 					}
 					break;
 				case VxEnum:
-					if (iomodel->f(VxEnum)){
-						for(j=0;j<6;j++)nodeinputs[j]=iomodel->f(VxEnum)[penta_vertex_ids[j]-1]/yts;
-						for(j=0;j<6;j++)cmmininputs[j]=iomodel->f(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
-						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->f(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
+					if (iomodel->Data(VxEnum)){
+						for(j=0;j<6;j++)nodeinputs[j]=iomodel->Data(VxEnum)[penta_vertex_ids[j]-1]/yts;
+						for(j=0;j<6;j++)cmmininputs[j]=iomodel->Data(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
+						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->Data(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
 						this->inputs->AddInput(new ControlInput(VxEnum,PentaVertexInputEnum,nodeinputs,cmmininputs,cmmaxinputs,i+1));
 					}
 					break;
 				case VyEnum:
-					if (iomodel->f(VyEnum)){
-						for(j=0;j<6;j++)nodeinputs[j]=iomodel->f(VyEnum)[penta_vertex_ids[j]-1]/yts;
-						for(j=0;j<6;j++)cmmininputs[j]=iomodel->f(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
-						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->f(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
+					if (iomodel->Data(VyEnum)){
+						for(j=0;j<6;j++)nodeinputs[j]=iomodel->Data(VyEnum)[penta_vertex_ids[j]-1]/yts;
+						for(j=0;j<6;j++)cmmininputs[j]=iomodel->Data(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
+						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->Data(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i]/yts;
 						this->inputs->AddInput(new ControlInput(VyEnum,PentaVertexInputEnum,nodeinputs,cmmininputs,cmmaxinputs,i+1));
 					}
 					break;
 				case DragCoefficientEnum:
-					if (iomodel->f(DragCoefficientEnum)){
-						for(j=0;j<6;j++)nodeinputs[j]=iomodel->f(DragCoefficientEnum)[penta_vertex_ids[j]-1];
-						for(j=0;j<6;j++)cmmininputs[j]=iomodel->f(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i];
-						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->f(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i];
+					if (iomodel->Data(DragCoefficientEnum)){
+						for(j=0;j<6;j++)nodeinputs[j]=iomodel->Data(DragCoefficientEnum)[penta_vertex_ids[j]-1];
+						for(j=0;j<6;j++)cmmininputs[j]=iomodel->Data(CmMinEnum)[(penta_vertex_ids[j]-1)*num_control_type+i];
+						for(j=0;j<6;j++)cmmaxinputs[j]=iomodel->Data(CmMaxEnum)[(penta_vertex_ids[j]-1)*num_control_type+i];
 						this->inputs->AddInput(new ControlInput(DragCoefficientEnum,PentaVertexInputEnum,nodeinputs,cmmininputs,cmmaxinputs,i+1));
 					}
@@ -5223,5 +5223,5 @@
 					/*Matice will take care of it*/ break;
 				default:
-					_error_("Control %s not implemented yet",EnumToStringx((int)iomodel->f(ControlTypeEnum)[i]));
+					_error_("Control %s not implemented yet",EnumToStringx((int)iomodel->Data(ControlTypeEnum)[i]));
 			}
 		}
@@ -5229,41 +5229,41 @@
 
 	//Need to know the type of approximation for this element
-	if(iomodel->f(ElementsTypeEnum)){
-		if (*(iomodel->f(ElementsTypeEnum)+index)==MacAyealApproximationEnum){
+	if(iomodel->Data(ElementsTypeEnum)){
+		if (*(iomodel->Data(ElementsTypeEnum)+index)==MacAyealApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,MacAyealApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==PattynApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==PattynApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,PattynApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==MacAyealPattynApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==MacAyealPattynApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,MacAyealPattynApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==HutterApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==HutterApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,HutterApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==StokesApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==StokesApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,StokesApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==MacAyealStokesApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==MacAyealStokesApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,MacAyealStokesApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==PattynStokesApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==PattynStokesApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,PattynStokesApproximationEnum));
 		}
-		else if (*(iomodel->f(ElementsTypeEnum)+index)==NoneApproximationEnum){
+		else if (*(iomodel->Data(ElementsTypeEnum)+index)==NoneApproximationEnum){
 			this->inputs->AddInput(new IntInput(ApproximationEnum,NoneApproximationEnum));
 		}
 		else{
-			_error_("Approximation type %s not supported yet",EnumToStringx((int)*(iomodel->f(ElementsTypeEnum)+index)));
+			_error_("Approximation type %s not supported yet",EnumToStringx((int)*(iomodel->Data(ElementsTypeEnum)+index)));
 		}
 	}
 
 	/*DatasetInputs*/
-	if (control_analysis && iomodel->f(WeightsEnum)) {
+	if (control_analysis && iomodel->Data(WeightsEnum)) {
 
 		/*Create inputs and add to DataSetInput*/
 		DatasetInput* datasetinput=new DatasetInput(WeightsEnum);
 		for(i=0;i<num_cm_responses;i++){
-			for(j=0;j<6;j++)nodeinputs[j]=iomodel->f(WeightsEnum)[(penta_vertex_ids[j]-1)*num_cm_responses+i];
+			for(j=0;j<6;j++)nodeinputs[j]=iomodel->Data(WeightsEnum)[(penta_vertex_ids[j]-1)*num_cm_responses+i];
 			datasetinput->inputs->AddObject(new PentaVertexInput(WeightsEnum,nodeinputs));
 		}
@@ -7520,18 +7520,18 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&yts,YtsEnum);
-	iomodel->constants->FindParam(&prognostic_DG,PrognosticDGEnum);
-	iomodel->constants->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	iomodel->constants->FindParam(&isstokes,IsstokesEnum);
-	iomodel->constants->FindParam(&beta,BetaEnum);
-	iomodel->constants->FindParam(&heatcapacity,HeatcapacityEnum);
-	iomodel->constants->FindParam(&referencetemperature,ReferencetemperatureEnum);
-	iomodel->constants->FindParam(&meltingpoint,MeltingpointEnum);
-	iomodel->constants->FindParam(&latentheat,LatentheatEnum);
+	iomodel->Constant(&yts,YtsEnum);
+	iomodel->Constant(&prognostic_DG,PrognosticDGEnum);
+	iomodel->Constant(&qmu_analysis,QmuAnalysisEnum);
+	iomodel->Constant(&isstokes,IsstokesEnum);
+	iomodel->Constant(&beta,BetaEnum);
+	iomodel->Constant(&heatcapacity,HeatcapacityEnum);
+	iomodel->Constant(&referencetemperature,ReferencetemperatureEnum);
+	iomodel->Constant(&meltingpoint,MeltingpointEnum);
+	iomodel->Constant(&latentheat,LatentheatEnum);
 
 
 	/*Checks if debuging*/
 	/*{{{2*/
-	_assert_(iomodel->f(ElementsEnum));
+	_assert_(iomodel->Data(ElementsEnum));
 	/*}}}*/
 
@@ -7548,5 +7548,5 @@
 
 	/*Recover vertices ids needed to initialize inputs*/
-	for(i=0;i<6;i++) penta_vertex_ids[i]=(int)iomodel->f(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
+	for(i=0;i<6;i++) penta_vertex_ids[i]=(int)iomodel->Data(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
 
 	/*Recover nodes ids needed to initialize the node hook.*/
@@ -7554,5 +7554,5 @@
 		//go recover node ids, needed to initialize the node hook.
 		//WARNING: We assume P1 elements here!!!!!
-		penta_node_ids[i]=iomodel->nodecounter+(int)iomodel->f(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
+		penta_node_ids[i]=iomodel->nodecounter+(int)iomodel->Data(ElementsEnum)[6*index+i]; //ids for vertices are in the elements array from Matlab
 	}
 
@@ -7569,6 +7569,6 @@
 
 			/*default vx,vy and vz: either observation or 0 */
-			if(!iomodel->f(VxEnum)){
-				if (iomodel->f(VxObsEnum)) for(i=0;i<6;i++)nodeinputs[i]=iomodel->f(VxObsEnum)[penta_vertex_ids[i]-1]/yts;
+			if(!iomodel->Data(VxEnum)){
+				if (iomodel->Data(VxObsEnum)) for(i=0;i<6;i++)nodeinputs[i]=iomodel->Data(VxObsEnum)[penta_vertex_ids[i]-1]/yts;
 				else                 for(i=0;i<6;i++)nodeinputs[i]=0;
 				this->inputs->AddInput(new PentaVertexInput(VxEnum,nodeinputs));
@@ -7576,6 +7576,6 @@
 				if(qmu_analysis) this->inputs->AddInput(new PentaVertexInput(QmuVxEnum,nodeinputs));
 			}
-			if(!iomodel->f(VyEnum)){
-				if (iomodel->f(VyObsEnum)) for(i=0;i<6;i++)nodeinputs[i]=iomodel->f(VyObsEnum)[penta_vertex_ids[i]-1]/yts;
+			if(!iomodel->Data(VyEnum)){
+				if (iomodel->Data(VyObsEnum)) for(i=0;i<6;i++)nodeinputs[i]=iomodel->Data(VyObsEnum)[penta_vertex_ids[i]-1]/yts;
 				else                 for(i=0;i<6;i++)nodeinputs[i]=0;
 				this->inputs->AddInput(new PentaVertexInput(VyEnum,nodeinputs));
@@ -7583,6 +7583,6 @@
 				if(qmu_analysis) this->inputs->AddInput(new PentaVertexInput(QmuVyEnum,nodeinputs));
 			}
-			if(!iomodel->f(VzEnum)){
-				if (iomodel->f(VzObsEnum)) for(i=0;i<6;i++)nodeinputs[i]=iomodel->f(VzObsEnum)[penta_vertex_ids[i]-1]/yts;
+			if(!iomodel->Data(VzEnum)){
+				if (iomodel->Data(VzObsEnum)) for(i=0;i<6;i++)nodeinputs[i]=iomodel->Data(VzObsEnum)[penta_vertex_ids[i]-1]/yts;
 				else                 for(i=0;i<6;i++)nodeinputs[i]=0;
 				this->inputs->AddInput(new PentaVertexInput(VzEnum,nodeinputs));
@@ -7590,5 +7590,5 @@
 				if(qmu_analysis) this->inputs->AddInput(new PentaVertexInput(QmuVzEnum,nodeinputs));
 			}
-			if(!iomodel->f(PressureEnum)){
+			if(!iomodel->Data(PressureEnum)){
 				for(i=0;i<6;i++)nodeinputs[i]=0;
 				if(qmu_analysis){
@@ -7601,10 +7601,10 @@
 				}
 			}
-			if(*(iomodel->f(ElementsTypeEnum)+index)==PattynStokesApproximationEnum){
+			if(*(iomodel->Data(ElementsTypeEnum)+index)==PattynStokesApproximationEnum){
 				/*Create VzPattyn and VzStokes Enums*/
-				if(iomodel->f(VzEnum) && iomodel->f(NodeOnStokesEnum)){
-					for(i=0;i<6;i++) nodeinputs[i]=iomodel->f(VzEnum)[penta_vertex_ids[i]-1]/yts*iomodel->f(NodeOnStokesEnum)[penta_vertex_ids[i]-1];
+				if(iomodel->Data(VzEnum) && iomodel->Data(NodeOnStokesEnum)){
+					for(i=0;i<6;i++) nodeinputs[i]=iomodel->Data(VzEnum)[penta_vertex_ids[i]-1]/yts*iomodel->Data(NodeOnStokesEnum)[penta_vertex_ids[i]-1];
 					this->inputs->AddInput(new PentaVertexInput(VzStokesEnum,nodeinputs));
-					for(i=0;i<6;i++) nodeinputs[i]=iomodel->f(VzEnum)[penta_vertex_ids[i]-1]/yts*(1-iomodel->f(NodeOnStokesEnum)[penta_vertex_ids[i]-1]);
+					for(i=0;i<6;i++) nodeinputs[i]=iomodel->Data(VzEnum)[penta_vertex_ids[i]-1]/yts*(1-iomodel->Data(NodeOnStokesEnum)[penta_vertex_ids[i]-1]);
 					this->inputs->AddInput(new PentaVertexInput(VzPattynEnum,nodeinputs));
 				}
@@ -7615,10 +7615,10 @@
 				}
 			}
-			if(*(iomodel->f(ElementsTypeEnum)+index)==MacAyealStokesApproximationEnum){
+			if(*(iomodel->Data(ElementsTypeEnum)+index)==MacAyealStokesApproximationEnum){
 				/*Create VzMacAyeal and VzStokes Enums*/
-				if(iomodel->f(VzEnum) && iomodel->f(NodeOnStokesEnum)){
-					for(i=0;i<6;i++) nodeinputs[i]=iomodel->f(VzEnum)[penta_vertex_ids[i]-1]/yts*iomodel->f(NodeOnStokesEnum)[penta_vertex_ids[i]-1];
+				if(iomodel->Data(VzEnum) && iomodel->Data(NodeOnStokesEnum)){
+					for(i=0;i<6;i++) nodeinputs[i]=iomodel->Data(VzEnum)[penta_vertex_ids[i]-1]/yts*iomodel->Data(NodeOnStokesEnum)[penta_vertex_ids[i]-1];
 					this->inputs->AddInput(new PentaVertexInput(VzStokesEnum,nodeinputs));
-					for(i=0;i<6;i++) nodeinputs[i]=iomodel->f(VzEnum)[penta_vertex_ids[i]-1]/yts*(1-iomodel->f(NodeOnStokesEnum)[penta_vertex_ids[i]-1]);
+					for(i=0;i<6;i++) nodeinputs[i]=iomodel->Data(VzEnum)[penta_vertex_ids[i]-1]/yts*(1-iomodel->Data(NodeOnStokesEnum)[penta_vertex_ids[i]-1]);
 					this->inputs->AddInput(new PentaVertexInput(VzMacAyealEnum,nodeinputs));
 				}
@@ -7645,12 +7645,12 @@
 			this->inputs->AddInput(new PentaVertexInput(VyMeshEnum,nodeinputs));
 			this->inputs->AddInput(new PentaVertexInput(VzMeshEnum,nodeinputs));
-			if (iomodel->f(TemperatureEnum) && iomodel->f(WaterfractionEnum)) {
+			if (iomodel->Data(TemperatureEnum) && iomodel->Data(WaterfractionEnum)) {
 				for(i=0;i<6;i++){
-					if(iomodel->f(TemperatureEnum)[penta_vertex_ids[i]-1] < meltingpoint-beta*iomodel->f(PressureEnum)[penta_vertex_ids[i]-1]){
-						nodeinputs[i]=heatcapacity*(iomodel->f(TemperatureEnum)[penta_vertex_ids[i]-1]-referencetemperature);
+					if(iomodel->Data(TemperatureEnum)[penta_vertex_ids[i]-1] < meltingpoint-beta*iomodel->Data(PressureEnum)[penta_vertex_ids[i]-1]){
+						nodeinputs[i]=heatcapacity*(iomodel->Data(TemperatureEnum)[penta_vertex_ids[i]-1]-referencetemperature);
 					}
 					else nodeinputs[i]=heatcapacity*
-					 (meltingpoint-beta*iomodel->f(PressureEnum)[penta_vertex_ids[i]-1]-referencetemperature)
-						+latentheat*iomodel->f(WaterfractionEnum)[penta_vertex_ids[i]-1];
+					 (meltingpoint-beta*iomodel->Data(PressureEnum)[penta_vertex_ids[i]-1]-referencetemperature)
+						+latentheat*iomodel->Data(WaterfractionEnum)[penta_vertex_ids[i]-1];
 				}
 				this->inputs->AddInput(new PentaVertexInput(EnthalpyEnum,nodeinputs));
Index: issm/trunk/src/c/objects/Elements/PentaHook.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/PentaHook.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Elements/PentaHook.cpp	(revision 9405)
@@ -51,5 +51,5 @@
 	
 	/*retrieve parameters: */
-	iomodel->constants->FindParam(&matpar_id,NumberOfElementsEnum); matpar_id++;
+	iomodel->Constant(&matpar_id,NumberOfElementsEnum); matpar_id++;
 
 	this->numanalyses=in_numanalyses;
